From 3f0decd4ee49e9de3682bbe5cbe57d82dbf1ae20 Mon Sep 17 00:00:00 2001
From: Johnson Chu <johnsoncodehk@gmail.com>
Date: Fri, 7 Mar 2025 01:44:50 +0800
Subject: [PATCH 09/13] fix(language-core): trigger targets dirty when
 associatedOnly is true

---
 packages/language-core/index.ts | 13 +++++++++----
 1 file changed, 9 insertions(+), 4 deletions(-)

diff --git a/packages/language-core/index.ts b/packages/language-core/index.ts
index 573a14b0..853feac7 100644
--- a/packages/language-core/index.ts
+++ b/packages/language-core/index.ts
@@ -67,14 +67,20 @@ export function createLanguage<T>(
 					const sourceScript = scriptRegistry.get(id)!;
 					if (sourceScript.languageId !== languageId || sourceScript.associatedOnly !== associatedOnly) {
 						this.delete(id);
+						triggerTargetsDirty(sourceScript);
 						return this.set(id, snapshot, languageId);
 					}
 					else if (associatedOnly) {
-						sourceScript.snapshot = snapshot;
+						if (sourceScript.snapshot !== snapshot) {
+							sourceScript.snapshot = snapshot;
+							triggerTargetsDirty(sourceScript);
+						}
 					}
 					else if (sourceScript.isAssociationDirty || sourceScript.snapshot !== snapshot) {
-						// snapshot updated
-						sourceScript.snapshot = snapshot;
+						if (sourceScript.snapshot !== snapshot) {
+							sourceScript.snapshot = snapshot;
+							triggerTargetsDirty(sourceScript);
+						}
 						const codegenCtx = prepareCreateVirtualCode(sourceScript);
 						if (sourceScript.generated) {
 							const { updateVirtualCode, createVirtualCode } = sourceScript.generated.languagePlugin;
@@ -95,7 +101,6 @@ export function createLanguage<T>(
 								return;
 							}
 						}
-						triggerTargetsDirty(sourceScript);
 					}
 					else {
 						// not changed

